//+---------------------------------------------------------+
//|                                         MACD .mq4 |
//|                                  Copyright  2007, amds |
//|          , |
//|     ,      |
//+---------------------------------------------------------+
#property copyright "amds"
#property link      ""
//----
#property indicator_chart_window
#property indicator_buffers 5
//---- style
#property indicator_color1 Blue
#property indicator_color2 LightGray
#property indicator_color3 RoyalBlue
#property indicator_color4 FireBrick
#property indicator_color5 Red
#property indicator_style5 2
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
//---- parameters
extern bool showMACD   = true;
extern bool showCandle = true;
extern int  fastMA     = 12;
extern int  slowMA     = 26;
extern int  signal     =  9;
extern int  method_MA  =  1;
extern int  price_MA   =  0;
extern int  TF         =  0;
//---- buffers
double Fast[], Slow[], Signal[], Up[], Dn[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(5);
   IndicatorDigits (Digits);
   IndicatorShortName("MACD ");
   
 if(showMACD == true)
   {
   SetIndexBuffer(0,Fast);
   SetIndexStyle (0,DRAW_LINE);
   SetIndexLabel (0,"EMA1");   
   
   SetIndexBuffer(1,Slow);
   SetIndexStyle (1,DRAW_LINE);
   SetIndexLabel (1,"EMA2");
   
   SetIndexBuffer(4,Signal);
   SetIndexStyle (4,DRAW_LINE);
   SetIndexLabel (4,"Signal");
   SetIndexDrawBegin(4,Slow);
   }
 else
   {
   SetIndexBuffer(0,Fast);
   SetIndexStyle (0,DRAW_NONE);
   SetIndexLabel (0,NULL);   
   
   SetIndexBuffer(1,Slow);
   SetIndexStyle (1,DRAW_NONE);
   SetIndexLabel (1,NULL);
   
   SetIndexBuffer(4,Signal);
   SetIndexStyle (4,DRAW_NONE);
   SetIndexLabel (4,NULL);
   SetIndexDrawBegin(4,Slow);
   }
   
 if(showCandle == true)
   {
   SetIndexBuffer(2,Up);   
   SetIndexStyle (2,DRAW_HISTOGRAM);
   SetIndexLabel (2,NULL);
   SetIndexDrawBegin(2,Slow);

   SetIndexBuffer(3,Dn);   
   SetIndexStyle (3,DRAW_HISTOGRAM);
   SetIndexLabel (3,NULL);
   SetIndexDrawBegin(3,Slow);
   }
 else
   {
   SetIndexBuffer(2,Up);   
   SetIndexStyle (2,DRAW_NONE);
   SetIndexLabel (2,NULL);
   SetIndexDrawBegin(2,Slow);
   
   SetIndexBuffer(3,Dn);   
   SetIndexStyle (3,DRAW_NONE);
   SetIndexLabel (3,NULL);
   SetIndexDrawBegin(3,Slow);
   }

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| MACD                                                       |
//+------------------------------------------------------------------+
int start()
 {
  int counted_bars = IndicatorCounted(), limit, N;
  
  if (counted_bars > 0) counted_bars--; 
      limit = Bars-counted_bars;
      
  if (TF <= Period()) TF = Period(); N = TF/Period();
  
//======   for   ======||
  for(int i=0; i<limit; i++)
      {
       Fast[i] = iMA(NULL, 0, fastMA*N, 0, method_MA, price_MA, i);
       Slow[i] = iMA(NULL, 0, slowMA*N, 0, method_MA, price_MA, i);
       
       Signal[i] = Fast[i]-iOsMA(NULL, 0, fastMA*N, slowMA*N, signal*N, price_MA, i);
      }
      
//====   for     MACD ====|| 
  for(i=0; i<limit; i++)
    
  if (Signal[i] < Signal[i+1] && Signal[i] < Signal[i+2] && Signal[i+1] < Signal[i+2])
      {
       Dn[i] = High[i];
       Up[i] = Low [i];
      }
       
  else
  if (Signal[i] > Signal[i+1] && Signal[i] > Signal[i+2] && Signal[i+1] > Signal[i+2])
      {
       Dn[i] = Low [i];
       Up[i] = High[i];
      }
       
  else
      {Up[i] = EMPTY_VALUE; Dn[i] = EMPTY_VALUE;}
//----
   return(0);
 }
//+------------------------------------------------------------------+